---
layout: page
title: Azure Synapse Analytics
nav_order: 5
parent: Getting-Started
---
# Getting started with RAPIDS Accelerator on Azure Synapse Analytics
 [Azure Synapse Analytics](https://docs.microsoft.com/en-us/azure/synapse-analytics/) is an analytics service that brings
 together enterprise data warehousing and Big Data analytics.

Synapse now offers the ability to create Apache Spark pools that use GPUs on the backend to run your Spark workloads on 
GPUs for accelerated processing. These are called 
[GPU-accelerated Apache Spark pools](https://docs.microsoft.com/en-us/azure/synapse-analytics/spark/apache-spark-gpu-concept).
Currently it ships with the RAPIDS Accelerator for Apache Spark version 21.10.

Please follow the Quickstart guides below to learn how to create and use GPU pools in Azure Synapse Analytics:
1. [Quickstart: Create an Apache Spark GPU-enabled Pool in Azure Synapse Analytics using the Azure portal](https://docs.microsoft.com/en-us/azure/synapse-analytics/quickstart-create-apache-gpu-pool-portal)
2. [Quickstart: Create an Apache Spark notebook to run on a GPU pool](https://docs.microsoft.com/en-us/azure/synapse-analytics/spark/apache-spark-rapids-gpu)

